import { IGraph } from "../types/IGraph";
import { IVertex } from "../types/IVertex";
import { UndirectedGraph } from "../main/UndirectedGraph";
import { DirectedGraph } from "../main/DirectedGraph";
import { IEdge } from "../types/IEdge";
/**
 * Graph generator
 */
export declare class GraphGenerator {
    static generateVertexNumber(max: number): number;
    static generateEdgesNumber(verticeNumber: number): number;
    /**
     * Returns the generated graph with exact vertex number
     * @param verticeNumber
     * @returns {IGraph}
     */
    static generate(verticeNumber?: number): IGraph<IVertex, IEdge>;
    static generateUndirectedGraph(): UndirectedGraph;
    static generateDirectedGraph(): DirectedGraph;
}
