"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Matrix operations
 */
var MatrixOperations = /** @class */ (function () {
    function MatrixOperations() {
    }
    MatrixOperations.Sum = function (matrix1, matrix2) {
        if (matrix1.length == matrix2.length && matrix1[0].length == matrix2[0].length) {
            for (var i = 0; i < matrix1.length; i++) {
                for (var j = 0; j < matrix1[i].length; j++) {
                    matrix1[i][j] += matrix2[i][j];
                }
            }
        }
        else {
            throw new Error('Incorrect matrix size');
        }
        return matrix1;
    };
    MatrixOperations.Multiply = function (matrix1, matrix2) {
        var result = [];
        if (matrix1[0].length == matrix2.length) {
            for (var i = 0; i < matrix1.length; i++) {
                result[i] = [];
                for (var k = 0; k < matrix2[i].length; k++) {
                    result[i][k] = 0;
                    for (var j = 0; j < matrix2.length; j++) {
                        result[i][k] += matrix1[i][j] * matrix2[j][k];
                    }
                }
            }
        }
        else {
            throw new Error('Incorrect matrix size');
        }
        return result;
    };
    MatrixOperations.Power = function (matrix, power) {
        if (power >= 0) {
            for (var k = 1; k < power; k++)
                matrix = MatrixOperations.Multiply(matrix, matrix);
        }
        else {
            throw new Error('Power must be >= 0');
        }
        return matrix;
    };
    MatrixOperations.Binary = function (matrix) {
        for (var i = 0; i < matrix.length; i++) {
            for (var j = 0; j < matrix[i].length; j++) {
                if (matrix[i][j] > 0) {
                    matrix[i][j] = 1;
                }
            }
        }
        return matrix;
    };
    MatrixOperations.DirectedAccessibility = function (matrix) {
        for (var i = 0; i < matrix.length; i++) {
            for (var j = 0; j < matrix.length; j++) {
                if (matrix[i][j] == 0 && matrix[j][i] == 1) {
                    matrix[i][j] = 1;
                }
            }
        }
        return matrix;
    };
    return MatrixOperations;
}());
exports.MatrixOperations = MatrixOperations;
//# sourceMappingURL=MatrixOperations.js.map