import { Edge } from "./Edge";
import { IVertex } from "../types/IVertex";
import { IWeightedEdge } from "../types/IWeightedEdge";
/**
 * @classdesc
 * Directed weighted edge
 */
export declare class DirectedWeightedEdge extends Edge implements IWeightedEdge {
    /**
     * @property
     * @private
     * Weight for the edge
     */
    private _weight;
    /**
     * @property
     * @public
     * Getter for _weight field
     * @returns {number}
     */
    get weight(): number;
    /**
     * @property
     * @public
     * Setter for _weigth field
     * @param newWeight
     */
    set weight(newWeight: number);
    /**
     * @override
     * @property
     * @public
     * Shows that edge is directed
     * @return {boolean}
     */
    get isDirected(): boolean;
    constructor(vertexOne: IVertex, vertexTwo: IVertex, weight: number);
}
