import { IVertex } from "../types/IVertex";
import { UndirectedGraph } from "../main/UndirectedGraph";
/**
 * @classdesc
 * Checkers for dominating and minimal dominating sets
 */
export declare class CheckSet {
    /**
     * Checker for a dominating set
     * @param vSet
     * @param givenGraph
     * @returns {boolean}
     * @constructor
     */
    isExternalStability(vSet: IVertex[], givenGraph: UndirectedGraph): boolean;
    /**
     * Checker for minimal dominating set
     * @param setEs
     * @param givenGraph
     * @returns {boolean}
     */
    isMinimal(setEs: IVertex[], givenGraph: UndirectedGraph): boolean;
}
